﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace TablMnoz
{
  class Tabl
  {
    //pola publiczne 
    public int Row1;
    public int Row2;
    public int Col1;
    public int Col2;
    //Wynikowa tabliczka mnożenia w postaci numerycznej
    public int[,] tablN;

    //publiczna metoda proceduralna
    //
    //Właściwe budowanie tabliczki mnożenia
    public void Wyznacz()
    {
      //tworzenie obiektu wynikowej tabliczki mnożenia w postaci
      //tablicy dwuwymiarowej o elementach typu int
      tablN = new int[Row2 - Row1 + 1, Col2 - Col1 + 1];
      //pętla iterująca po wierszach
      for (int nr = Row1; nr <= Row2; nr++)
      {
        //pętla iterująca po kolumnach
        for (int nc = Col1; nc <= Col2; nc++)
        {
          //wyznaczanie wartości elementu na skrzyżowaniu kolumny nc i wiersza nr
          tablN[nr - Row1, nc - Col1] = nr * nc;
        }
      }
    }



    //publiczna metoda funkcyjna
    //
    //Dodatek ułatwiający uzyskanie widoku wynikowej tabliczki  
    //mnożenia do wyświetlenia w postaci jednego łańcucha znaków
    public string ToText()
    {
      //obiekt do efektywnego wieloetapowego konstruowania wartości typu string
      StringBuilder sb = new StringBuilder();
      //pętla iterująca po wierszach tablicy  
      for (int nr = Row1; nr <= Row2; nr++)
      {
        //pętla iterująca po kolumnach bieżącego wiersza tablicy
        for (int nc = Col1; nc <= Col2; nc++)
        {
          //element tablicy dodawany do "budowniczego stringów" sformatowany jako ciąg cyfr 
          //poprzedzony spacjami, łącznie zajmujący 5 znaków,
          //dodatkowo poprzedzony jedną spacją
          //Patrz: dokumentacja funkcji string.Format
          sb.Append(string.Format(" {0,5}", tablN[nr - Row1, nc - Col1]));
        }
        //nowy wiersz
        sb.Append("\r\n");
      }
      //zwrócenie wynikowego łąńcucha znaków
      return sb.ToString();
    }



  }
}
